<?php

namespace Drupal\flysystem;

use Drupal\Core\Site\Settings;
use Drupal\Core\StreamWrapper\LocalStream;
use Drupal\flysystem\Adapter\FlysystemUrlTrait;
use League\Flysystem\FilesystemAdapter;

/**
 * FlysystemStreamWrapper implementation for Drupal compatibility.
 */
abstract class FlysystemStreamWrapper extends LocalStream {

  use FlysystemUrlTrait {
    getExternalUrl as getDownloadlUrl;
  }

  /**
   * The site settings.
   *
   * @var \Drupal\Core\Site\Settings
   */
  protected $settings;

  /**
   * Flysystem Adapter.
   *
   * @var \League\Flysystem\FilesystemAdapter
   */
  protected $adapter;

  /**
   * Constructor.
   *
   * @param \Drupal\Core\Site\Settings $settings
   *   The site settings.
   * @param \League\Flysystem\FilesystemAdapter $adapter
   *   The FlysystemAdapter for this stream wrapper implementation.
   */
  public function _construct(Settings $settings, FilesystemAdapter $adapter) {
    $this->settings = $settings;
    $this->adapter = $adapter;
  }

}
